<!--
 * @Description: 
 * @Author: gcz
 * @Date: 2024-04-23 10:30:35
 * @LastEditors: gcz
 * @LastEditTime: 2024-05-07 11:22:51
 * @FilePath: \great_webui\src\views\statisticalReport\product.vue
 * @Copyright: Copyright (c) 2016~2024 by gcz, All Rights Reserved. 
-->
<template>
    <div class="app-container">
      <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="40px">
        <!-- <el-form-item label="演出厅" prop="auditoriumId" label-width="70px">
          <el-select
            v-model="queryParams.auditoriumId"
            placeholder="演出厅"
            clearable
            style="width: 100%"
            @change="pagePerformTimeListFun(selectTime)"
          >
            <el-option
              v-for="dict in merchantTheatreAuditoriumListS"
              :key="dict.id"
              :label="dict.name"
              :value="dict.id"
            />
          </el-select>
        </el-form-item> -->
        <el-form-item label="场次日期" :required="true" label-width="85px">
          <el-date-picker
            style="width: 230px;"
            v-model="selectTime"
            type="daterange"
            @change="pagePerformTimeListFun"
            value-format="yyyy-MM-dd"
            placeholder="日期">
          </el-date-picker>
        </el-form-item>
        <el-form-item label="场次" v-if="!multiPerformDate" :required="!multiPerformDate" label-width="55px">
        <el-select
          v-model="queryParams.performTimeId"
          placeholder="场次"
          clearable
          style="width: 100%"
        >
          <el-option
            v-for="dict in pagePerformTimeList"
            :key="dict.id"
            :label="dict.timeSnapshot+'('+dict.performTimeStart+'-'+dict.performTimeEnd+')'"
            :value="dict.id"
          />
        </el-select>
      </el-form-item>
        <el-form-item>
          <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
          <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
        </el-form-item>
      </el-form>
      <el-row :gutter="10" class="mb8"  style="margin-left: 0; margin-top: 10px">
        <el-button
          type="primary"
          size="mini"
          icon="el-icon-download"
          :disabled="dataList.length === 0"
          v-hasPermi="['product:product:downloadExcel']"
          @click="handleExport"
          v-loading.fullscreen.lock="handleExportLoading"
          element-loading-text="正在拼命生成数据中..."
          element-loading-spinner="el-icon-loading"
          element-loading-background="rgba(0, 0, 0, 0.5)"
        >导出excel</el-button>
        <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
      </el-row>
  
      <el-table ref="tables" v-loading="loading" :data="dataList" border>
        <el-table-column label="序号" align="center" type="index" width="60"></el-table-column>
        <!-- <el-table-column label="场次日期" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.performDate }}</span>
          </template>
        </el-table-column> -->
        <el-table-column label="产品名称" align="center" prop="name" />
        <el-table-column label="订单数（笔）" align="center" prop="orderNum" />
        <el-table-column label="应收总额（元）" align="center" prop="price" />
        <el-table-column label="实收总额（元）" align="center" prop="realPrice" />
        <el-table-column label="已售票数（张）" align="center" prop="buyNum" />
        <el-table-column label="核销票数（张）" align="center" prop="checkNum" />
        <el-table-column label="未核销票数（张）" align="center" prop="noCheckNum" />
        <el-table-column label="退票数（张）" align="center" prop="refundNum" />
        <el-table-column label="退票金额（元）" align="center" prop="refundAmount" />
      </el-table>
  
      <pagination
        v-show="total>0"
        :total="total"
        :page.sync="queryParams.pageNum"
        :limit.sync="queryParams.pageSize"
        @pagination="getList"
      />
  
    </div>
  </template>
  
  <script>
  import {merchantTheatreAuditoriumList} from '@/api/windowTicketSales/ticketingSales'
  import { productOrderCount, downProductOrderListXls } from '@/api/statisticalReport/statistics'
  import { exportExcel } from '@/utils/exportexcel'
  import { seatPricePageList } from '@/api/distribution/ticketMr'
  import { pagePerformTimeList } from "@/api/schedulingMr/schedulingMr"
  import moment from "moment"
  export default {
    name: "agreement",
    dicts: ['agreement_type'],
    data() {
      return {
        // 遮罩层
        loading: true,
        // 选中数组
        ids: [],
        // 非单个禁用
        single: true,
        // 非多个禁用
        multiple: true,
        // 显示搜索条件
        showSearch: true,
        // 总条数
        total: 0,
        // 用户表格数据
        dataList: [],
        // 弹出层标题
        title: "",
  
        // 是否显示弹出层
        open: false,
        // 日期范围
        dateRange: [],
        // 查询参数
        queryParams: {
          auditoriumId:'',
          // pageNum: 1,
          // pageSize: 10,
        },
        visibleStatus: false,
        newObj: {},
        visibleType: '',
        handleExportLoading: false,
        tableData: {},
        ticketList: [],
        seatList: [],
        multiPerformDate:false,
        pagePerformTimeList: [], // 场次列表
        selectTime:'',
        merchantTheatreAuditoriumListS: [],//演出厅
      };
    },
    created() {
      // this.$set(this.queryParams,'time',moment().format("yyyy-MM-DD"))
      // this.merchantTheatreAuditoriumListFun();//演出厅
      this.$set(this,'selectTime',[moment().format("yyyy-MM-DD"),moment().format("yyyy-MM-DD")]);
      this.pagePerformTimeListFun(this.selectTime)
      // this.getList();
      // this.ticketListApi();
    },
    methods: {
      /** 查询列表 */
      getList() {
        this.loading = true;
        if(this.selectTime){
          this.queryParams.performDateStart = this.selectTime[0];
          this.queryParams.performDateEnd = this.selectTime[1];
        }
        // productOrderCount(this.addDateRange(this.queryParams, this.dateRange))
        productOrderCount(this.queryParams)
        .then(response => {
            this.dataList = response.data.rows;
            this.total = response.data.total;
            this.loading = false;
          }
        ).catch(response => {
          this.loading = false;
        });
      },
      /** 票务列表查询 */
      ticketListApi() {
        this.ticketList = []
        seatPricePageList(this.addDateRange({pageNum: 1, pageSize: 100}))
          .then(response => {
            let ticketItemList = []
            response.data.rows.forEach(item => {
              if(ticketItemList.indexOf(item.goodsId) == -1){
                this.ticketList.push(item);
                ticketItemList.push(item.goodsId);
              }
            })
          });
      },
      /** 座位类型列表 */
      getSeatTypeList(obj) {
        seatPricePageList(this.addDateRange({pageNum: 1, pageSize: 100, goodsId: obj.goodsId}))
          .then(response => {
            let ticketList = []
            response.data.rows.forEach(item => {
              if(ticketList.indexOf(item.seatTypeId) == -1){
                this.seatList.push(item);
                ticketList.push(item.seatTypeId);
              }
            })
          });
      },
      // 取消按钮
      cancel() {
        this.open = false;
      },
      // 票务改变事件
      goodsChangeEven() {
        this.seatList = [];
        this.$set(this.queryParams, 'seatTypeId', '');
        let selectMap = {goodsId: this.queryParams.goodsId}
        this.getSeatTypeList(selectMap);
      },
      /** 搜索按钮操作 */
      handleQuery() {
        // this.queryParams.pageNum = 1;
        this.getList();
      },
      /** 重置按钮操作 */
      resetQuery() {
        this.dateRange = [];
        this.seatList = [];
        this.$set(this.queryParams, 'time', '');
        this.$set(this, 'selectTime', '');
        this.$set(this.queryParams, 'auditoriumId', '');
        this.$set(this.queryParams, 'performDateStart', '');
        this.$set(this.queryParams, 'performDateEnd', '');
        this.$set(this.queryParams, 'goodsId', '');
        this.$set(this.queryParams, 'seatTypeId', '');
        this.$set(this.queryParams, 'performTimeId', '');
        // this.queryParams.pageNum = 1;
        this.multiPerformDate = false;

        //必须要有默认值
        this.$set(this,'selectTime',[moment().format("yyyy-MM-DD"),moment().format("yyyy-MM-DD")]);
        this.pagePerformTimeListFun(this.selectTime)
        // this.handleQuery();
      },
      /**
       * 导出报表
       * @date 2022-10-24
       * @returns {any}
       */
      handleExport() {
        this.$confirm('您确定要导出当前查询的数据吗？', '提示', {
          confirmButtonText: '确定 ',
          cancelButtonText: '取消 ',
          type: 'warning'
        })
          .then(() => {
            this.handleExportLoading = true;
            // const { pageNum, pageSize} = this.params;
            let postMap = {}
            for (let key in this.queryParams) {
              if(key != 'pageNum' && key != 'pageSize'){
                postMap[key] = this.queryParams[key]
              }
            }
            downProductOrderListXls(postMap)
              .then((res) => {
                exportExcel(res, '产品销售统计', '.xlsx');
                this.handleExportLoading = false;
              })
              .catch(() => {
                this.handleExportLoading = false;
              });
          })
          .catch(() => {
            this.$message.info('您已取消导出！');
          });
      },
      async pagePerformTimeListFun(value) {
            // console.log('value',value);
            try {
                this.pagePerformTimeList = []
                this.$set(this.queryParams,'performTimeId',null)
                if(!value){
                return
                }
                if(value.length==2&&value[0]==value[1]){
                this.multiPerformDate = false
                }else{
                this.multiPerformDate = true
                return
                }
                let { data,code } = await pagePerformTimeList({
                performDate: value[0],
                pageNum: 1,
                pageSize: 999
                })
                this.pagePerformTimeList = [].concat(data.rows);
                if(data.rows[0]){
                  this.queryParams.performTimeId = data.rows[0].id;
                }
                this.getList();
            } catch (error) {
                
            }
        },
        /**  获取演出厅  */
        async merchantTheatreAuditoriumListFun(){
            try {
                let res = await merchantTheatreAuditoriumList({
                    pageNum: 1,
                    pageSize: 999
                })
                if(res.code == 200){
                    this.merchantTheatreAuditoriumListS = res.data.rows
                    if(this.merchantTheatreAuditoriumListS.length>0){
                        this.$set(this.queryParams,'auditoriumId',this.merchantTheatreAuditoriumListS[0].id)
                        this.pagePerformTimeListFun(this.selectTime)
                    }
                }
            } catch (error) {
                
            }
        },
    }
  };
  </script>
  